#ifndef _INCLUDE_H_
#define _INCLUDE_H_

#define _CRT_SECURE_NO_DEPRECATE		1
#define _CRT_SECURE_NO_WARNINGS			1
#define _CRT_NONSTDC_NO_WARNINGS		1
#define WIN32_LEAN_AND_MEAN
#ifndef _WIN32_WINNT
#define _WIN32_WINNT                0x500
#endif

// ~~~

#include <winsock2.h>
#include <windows.h>
#include <ntdll.h>
#include <shlwapi.h>
#include <wininet.h>
#include <shlobj.h>
#include <tlhelp32.h>
#include <shellapi.h>
#include <stdio.h>
#include <tchar.h>
#include <stdarg.h>
#include <Stierr.h>
#include <ntstatus.h>
#include <Psapi.h>
#ifdef __cplusplus
#include <string.h>
#include <algorithm>
//#include <strsafe.h>
#include <gdiplus.h>
#include <gdiplusflat.h>
#include <Wincrypt.h>
#include <comutil.h>
#include <Wtsapi32.h>
#endif
#include <intrin.h>

// ~~~

#define DLLEXPORT extern "C" __declspec(dllexport)

// ~~~
HANDLE StartThread(
    PVOID Address, 
    PVOID Param,
    BOOL HandleClose
    );
// ~~~
#define checkmem_forread(x, s)	!IsBadReadPtr((FARPROC)x, s)
// ~~~
#define GetCurrentProcess()				(HANDLE)0xFFFFFFFF
#define GetCurrentThread()				(HANDLE)0xFFFFFFFE
// ~~~
#define _fcreate(Name)					CreateFile(Name, GENERIC_READ|GENERIC_WRITE, FILE_SHARE_READ|FILE_SHARE_WRITE|FILE_SHARE_DELETE, NULL, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0)
#define _fwrite(hFile, Buffer, Length)	{ DWORD suc; WriteFile(hFile, Buffer, Length, &suc, NULL); }
#define _fclose(hFile)					CloseHandle(hFile)
#define _fdump(Name, Buffer, Length)	{ DeleteFile(Name); HANDLE hFile = _fcreate(Name); if (hFile) {	_fwrite(hFile, Buffer, Length); _fclose(hFile); } }
#define _fadd(Name, Buffer, Length)		{ HANDLE hFile = _fcreate(Name); if (hFile) { SetFilePointer(hFile, 0, 0, FILE_END); _fwrite(hFile, Buffer, Length); _fclose(hFile); } }
// ~~~
#ifndef SKIP_MEMORYMANAGER
#ifdef NDEBUG
#define malloc(Size)		(Size ? (HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, (SIZE_T)(Size + 1))) : NULL)
#define realloc(Mem, Size)	(Size ? (Mem ? HeapReAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, (PVOID)(Mem), Size) : malloc(Size)) : NULL)
#define free(Mem)			(Mem ? (HeapValidate(GetProcessHeap(), NULL, Mem) ? (HeapFree(GetProcessHeap(), NULL, (PVOID)(Mem)), Mem = NULL) : NULL) : NULL)
#else
#ifdef __cplusplus
extern "C" {
#endif
void* __cdecl dmalloc(size_t s);
void* __cdecl drealloc(void* p, size_t s);
void __cdecl dfree(void* p);
#ifdef __cplusplus
}
#endif
#define malloc				dmalloc
#define realloc				drealloc
#define free				dfree
#endif
#endif
// ~~~
//-------------------------------------------------------------------------------------------------------------------------------
#define InitializeListHead(ListHead) (\
    (ListHead)->Flink = (ListHead)->Blink = (ListHead))

#define IsListEmpty(ListHead) \
    ((ListHead)->Flink == (ListHead))

#define RemoveHeadList(ListHead) \
    (ListHead)->Flink;\
{RemoveEntryList((ListHead)->Flink)}

#define RemoveTailList(ListHead) \
    (ListHead)->Blink;\
{RemoveEntryList((ListHead)->Blink)}

#define RemoveEntryList(Entry) {\
    PLIST_ENTRY _EX_Blink;\
    PLIST_ENTRY _EX_Flink;\
    _EX_Flink = (Entry)->Flink;\
    _EX_Blink = (Entry)->Blink;\
    _EX_Blink->Flink = _EX_Flink;\
    _EX_Flink->Blink = _EX_Blink;\
}

#define InsertTailList(ListHead,Entry) {\
    PLIST_ENTRY _EX_Blink;\
    PLIST_ENTRY _EX_ListHead;\
    _EX_ListHead = (ListHead);\
    _EX_Blink = _EX_ListHead->Blink;\
    (Entry)->Flink = _EX_ListHead;\
    (Entry)->Blink = _EX_Blink;\
    _EX_Blink->Flink = (Entry);\
    _EX_ListHead->Blink = (Entry);\
}

#define InsertHeadList(ListHead,Entry) {\
    PLIST_ENTRY _EX_Flink;\
    PLIST_ENTRY _EX_ListHead;\
    _EX_ListHead = (ListHead);\
    _EX_Flink = _EX_ListHead->Flink;\
    (Entry)->Flink = _EX_Flink;\
    (Entry)->Blink = _EX_ListHead;\
    _EX_Flink->Blink = (Entry);\
    _EX_ListHead->Flink = (Entry);\
}

#define PopEntryList(ListHead) \
    (ListHead)->Next;\
{\
    PSINGLE_LIST_ENTRY FirstEntry;\
    FirstEntry = (ListHead)->Next;\
    if (FirstEntry != NULL) {     \
    (ListHead)->Next = FirstEntry->Next;\
    }                             \
}

#define PushEntryList(ListHead,Entry) \
    (Entry)->Next = (ListHead)->Next; \
    (ListHead)->Next = (Entry)
//-------------------------------------------------------------------------------------------------------------------------------
#ifndef SKIPDEBUG

#ifndef NDEBUG
void DebugOut(PCHAR szPrefix, PCHAR szFormat, ...);
#define DebugWrite(...)			DebugOut("[tid:%d] : [gle:%d] : "__FUNCTION__"() : ", __VA_ARGS__)
#define DebugEnter(...)			DebugOut("[tid:%d] : [gle:%d] : [ENTER] : "__FUNCTION__"() : ", __VA_ARGS__)
#define DebugLeave(...)			DebugOut("[tid:%d] : [gle:%d] : [LEAVE] : "__FUNCTION__"() : ", __VA_ARGS__)
#define __INT3   __asm int 3
#else
#define DebugWrite(...)
#define DebugEnter(...)
#define DebugLeave(...)
#define __INT3
#endif

#endif
// ------------------------------------------------------------------------------------------------------------------------------
#define __MARKER __asm inc eax __asm dec eax
#define PAGE_SIZE	0x1000
//-------------------------------------------------------------------------------------------------------------------------------
#define _strcpy_s(StrDest, DestSize, StrSrc) { ZeroMemory(StrDest, DestSize); StrSrc ? strlen(StrSrc) ? (CopyMemory(StrDest, StrSrc, strlen(StrSrc) >= DestSize ? DestSize - 1 : strlen(StrSrc))) : FALSE : FALSE; }
//-------------------------------------------------------------------------------------------------------------------------------
#define AFTER_PTRANSFER_BEGIN			static int pid = 0; if (pid != GetCurrentProcessId()) {
#define AFTER_PTRANSFER_END				pid = GetCurrentProcessId(); }
#define BEFORE_PTRANSFER_BEGIN			static int pid = 0; if (!pid || pid == GetCurrentProcessId()) {
#define BEFORE_PTRANSFER_END			} pid = GetCurrentProcessId();
//-------------------------------------------------------------------------------------------------------------------------------

#endif